{-------------------------------------------------------}
{                                                       }
{    The DBTreeNavigator example   is Copyright  1996  }
{         by Li Ying All Rights Reserved                }
{                  version 1.00                         }
{-------------------------------------------------------}


//*****************************************************
//     In this typical example ,we use DBTreeNavigator
//        in four steps in the code writing .
//     You can use seaching "step" to get there.
//*****************************************************

unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, DBGrids, ExtCtrls, DBCtrls, DB, DBTables, StdCtrls, Menus,
  ComCtrls , Mask, Treenavi, StruTree;

type

  TFmMain = class(TForm)
    DBNavigator1: TDBNavigator;
    MainMenu1: TMainMenu;
    About1: TMenuItem;
    RadioGroup1: TRadioGroup;
    CheckBox1: TCheckBox;
    Button1: TButton;
    CheckBox2: TCheckBox;
    Label12: TLabel;
    PageControl2: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    DBTreeNavigator1: TDBTreeNavigator;
    StructureTree1: TStructureTree;
    PageControl1: TPageControl;
    TSCompany: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    DBEdit1: TDBEdit;
    DBEdit2: TDBEdit;
    DBMemo1: TDBMemo;
    TSProductSeries: TTabSheet;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    DBEdit3: TDBEdit;
    DBEdit4: TDBEdit;
    DBEdit5: TDBEdit;
    DBMemo2: TDBMemo;
    TSProduct: TTabSheet;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    DBEdit6: TDBEdit;
    DBEdit7: TDBEdit;
    DBEdit8: TDBEdit;
    DBMemo3: TDBMemo;
    TSDepartment: TTabSheet;
    ScrollBox: TScrollBox;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    EditDepartmentID: TDBEdit;
    EditDepartmentName: TDBEdit;
    EditCompanyID: TDBEdit;
    TSText: TTabSheet;
    Memo1: TMemo;
    ImageList1: TImageList;

    procedure About1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);

    procedure rejustobject(Sender: TObject; objectno: integer);
    procedure RadioGroup1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure DBTreeNavigator1Rejust(Sender: TObject;
      ObjectNode: TTreeNode);
  private
    { Private declarations }

  public
    { Public declarations }

end;

var
  FmMain: TFmMain;

  lastobjnode:Ttreenode;

implementation

uses data, About;

  {$R *.DFM}

procedure TFmMain.About1Click(Sender: TObject);
var
  fmAboutBox : TFmAboutBox;
begin
  FmAboutBox := TFmAboutBox.Create(self);
  try
    FmAboutBox.showModal;
  finally
    FmAboutBox.free;
  end;
end;

procedure Tfmmain.rejustobject(Sender: TObject; objectno: integer);
begin
   if (not checkbox2.checked) then exit;
                            // need not to rejust follow DBTreeNavigator

   if objectno=-1 then exit;  // means the tree be NOT active

// step 4 : to write a  proedure responsing the OnRejust event
//         and you must link it to the event OnRejust,of course.

// the OnRejust event give us a chance to rejust UI
//      according to the new current object(datasource)

// in THIS procedure ,we do two things.
// 1 of 2. :to change the active page of page control
//             and to change the datasource of DBNavigator

     case objectno of         // objectno : the order in the objectlist
     0: begin
             pagecontrol1.activepage:=TSCompany;
             dbnavigator1.datasource:=dm.CompanySource;
        end;
     1: begin
             pagecontrol1.activepage:=TSProductSeries;
             dbnavigator1.datasource:=dm.ProductSSource;
        end;
     2: begin
             pagecontrol1.activepage:=TSProduct;
             dbnavigator1.datasource:=dm.ProductSource;
        end;
      end;

 // 2 of 2. : to change the caption of the pages in the pagecontrol
{
     TSCompany.caption:=Tfield(dbtreenavigator1.objectlist.items[0]).asstring;
     TSProductSeries.caption:=Tfield(dbtreenavigator1.objectlist.items[1]).asstring;
     TSProduct.caption:=Tfield(dbtreenavigator1.objectlist.items[2]).asstring;
}
end;

procedure TFmMain.formCreate(Sender: TObject);
begin

 // step 1 : to form the object list

 // The following is the code in 1.0
 // Now we can set these at design time
{
     with dbtreenavigator1 do
      begin
          objectlist.add(dm.CompanyName );
          objectlist.add(dm.ProductSName);
          objectlist.add(dm.ProductName);
      end;
 }
// step 2 : to set the properties and fields of DBTreeNavigator,
//                     if needed.
// Now we can set these at design time

// step 3 : to set the property active to true
 // The following is the code in 1.0
 // Now we can set these at design time

{
      dbtreenavigator1.active:=true;
 }
  end;
 procedure TFmMain.RadioGroup1Click(Sender: TObject);
 var now_itemindex:integer;
 begin

   if DBTreeNavigator1.static then
      now_itemindex:=0
   else
        now_itemindex:=1;

   if now_itemindex=RadioGroup1.itemindex then
       exit;

   case RadioGroup1.itemindex of
    0:  Begin
           DBTreeNavigator1.static:=true;
        end;
    1:  Begin
           DBTreeNavigator1.static:=false;
        end;
    end;

//  The following code is need not
//        for if you change the importent property
//         the following code is executed automacally

//    DBTreeNavigator1.active:=false;
//    DBTreeNavigator1.active:=true;
//
end;

procedure TFmMain.CheckBox1Click(Sender: TObject);
begin
  if checkBox1.checked<>DBTreeNavigator1.active then
     DBTreeNavigator1.active:=checkBox1.checked;
end;

procedure TFmMain.Button1Click(Sender: TObject);
begin
     DBTreeNavigator1.refreshcurrentChildrenNode;
end;

procedure TFmMain.DBTreeNavigator1Rejust(Sender: TObject;
  ObjectNode: TTreeNode);
begin
   if checkbox2.checked<>true then exit;

   if ObjectNode.text='Company:CompanyName' then
      pageControl1.activepage:=TSCompany
   else
   if ObjectNode.text='ProductS:ProductSName' then
      pageControl1.activepage:=TSProductseries
   else
   if ObjectNode.text='Product:ProductName' then
      pageControl1.activepage:=TSProduct
   else   if ObjectNode.text='department:DepartmentName' then
      pageControl1.activepage:=TSDepartment
   else
      pageControl1.activepage:=TSText

end;

end.
